#include "AutoAirblast.h"
#include "Util.h"
#include "SDK.h"

CAutoAirblast eAutoAirblast;



Vector EstimateAbsVelocity(CBaseEntity *ent);
void ChangeViewangles(Vector origin, Vector target, CUserCmd *cmd, bool silent);
bool IsReflectable(CBaseEntity *ent, int lTeamNum, const char* name);
void CAutoAirblast::Start(CBaseEntity* pPlayer, CUserCmd* pUserCmd)
{
	if (!eTriggerbot.airblast.value)
		return;

	if (!Util->IsKeyPressed(eTriggerbot.airblastkey.value))
		return;

	if (pPlayer->GetLifeState() != LIFE_ALIVE)
		return;

	if (pPlayer->GetClassNum() != TF2_Pyro)
		return;

	if (pPlayer->GetActiveWeapon()->GetSlot() != 0)
		return;

	int iClassID = pPlayer->GetActiveWeapon()->GetClientClass()->iClassID;
	
	if (iClassID == 594)
		return;

	float closest_dist = 0.0f;
	Vector closest_vec;
	for (int i = 0; i < gInts.EntList->GetHighestEntityIndex(); i++)
	{

		CBaseEntity *ent = gInts.EntList->GetClientEntity(i);

		if (!ent)
			continue;

		if (ent->IsDormant())
			continue;

		if (ent->GetTeamNum() == pPlayer->GetTeamNum())
			continue;

		if (!IsReflectable(ent, pPlayer->GetTeamNum(), ent->GetClientClass()->chName))
			continue;

		auto net = reinterpret_cast<INetChannelInfo*>(gInts.Engine->GetNetChannelInfo());

		float latency = net->GetLatency(FLOW_OUTGOING) + net->GetLatency(FLOW_INCOMING);
		Vector velocity;
		velocity = EstimateAbsVelocity(ent);
		Vector predicted_proj = ent->GetAbsOrigin() +(velocity * latency);
		

		float dist = predicted_proj.DistToSqr(pPlayer->GetAbsOrigin());

		if (dist < closest_dist || closest_dist == 0.0f)
		{
			closest_dist = dist;
			closest_vec = predicted_proj;
		}
	}

	if (closest_dist == 0 || closest_dist > 34400)
		return;

	Vector previousAngles = pUserCmd->viewangles;

	if (eTriggerbot.airblastrage.value)
	{
		ChangeViewangles(pPlayer->GetEyePosition(), closest_vec, pUserCmd, gCvars.autoairblast_silent);
	}

	pUserCmd->buttons |= IN_ATTACK2;

	if (!gCvars.autoairblast_silent)
		pUserCmd->viewangles = previousAngles;

	return;
}

	Vector EstimateAbsVelocity(CBaseEntity *ent)
	{
		typedef void(__thiscall * EstimateAbsVelocityFn)(CBaseEntity *, Vector &);
	
		static DWORD dwFn = gSignatures.GetClientSignature("E8 ? ? ? ? F3 0F 10 4D ? 8D 85 ? ? ? ? F3 0F 10 45 ? F3 0F 59 C9 56 F3 0F 59 C0 F3 0F 58 C8 0F 2F 0D ? ? ? ? 76 07") + 0x1;
	
		static DWORD dwEstimate = ((*(PDWORD)(dwFn)) + dwFn + 4);
	
		EstimateAbsVelocityFn vel = (EstimateAbsVelocityFn)dwEstimate;
	
		Vector v;
		vel(ent, v);
	
		return v;
	}

	void ChangeViewangles(Vector origin, Vector target, CUserCmd *cmd, bool silent)
	{
		Vector angles, tr;
		tr = (target - origin);
		VectorAngles(tr, angles);
		NormalizeAngles(angles);
		cmd->viewangles = angles;
		if (!silent)
			gInts.Engine->SetViewAngles(cmd->viewangles);
	}

	bool IsReflectable(CBaseEntity *ent, int lTeamNum, const char* name)
	{
		if (!strcmp(name, "CTFProjectile_SentryRocket")
			|| !strcmp(name, "CTFProjectile_Arrow")
			|| !strcmp(name, "CTFProjectile_HealingBolt")
			|| !strcmp(name, "CTFProjectile_EnergyBall")
			|| !strcmp(name, "CTFProjectile_Flare")
			|| !strcmp(name, "CTFProjectile_Jar")
			|| !strcmp(name, "CTFProjectile_JarMilk")
			|| !strcmp(name, "CTFProjectile_Cleaver")
			|| !strcmp(name, "CTFProjectile_Throwable")
			|| !strcmp(name, "CTFProjectile_Rocket")
			|| !strcmp(name, "CTFGrenadePipebombProjectile")
			|| !strcmp(name, "CTFProjectile_ThrowableRepel")
			|| !strcmp(name, "CTFProjectile_ThrowableBrick")
			|| !strcmp(name, "CTFProjectile_ThrowableBreadMonster")
			&& ent->GetTeamNum() != lTeamNum)
			return true;

		return false;
	}

