#include "SDK.h"
#include "Client.h"
#include "Panels.h"
#include "Menu.h"
#include "CMat.h"
#include <Windows.h>
#pragma comment(lib, "Winmm.lib")

float SteamAPI_ServerNonLan = false;

CGlobalVariables gCvars;
CInterfaces gInts;

CreateInterface_t EngineFactory = NULL;
CreateInterface_t ClientFactory = NULL;
CreateInterface_t VGUIFactory = NULL;
CreateInterface_t VGUI2Factory = NULL;
CreateInterface_t CvarFactory = NULL;
CreateInterfaceFn SteamFactory = NULL;
CreateInterfaceFn MaterialSystemFactory = NULL;

ITFMatchGroupDescription* GetMatchGroupDescription(int& idx)
{
	typedef ITFMatchGroupDescription* (_cdecl* GetFn)(int&);
	static GetFn Get = (GetFn)(gSignatures.GetClientSignature("55 8B EC 8B 45 08 8B 00 83 F8 FF"));
	return Get(idx);
}

DWORD WINAPI dwMainThread( LPVOID lpArguments )
{
	if (gInts.Client == NULL)
	{
		float IsOnlineServer = false;
	    if (SteamAPI_ServerNonLan)
		    IsOnlineServer = true;
		else
		    IsOnlineServer = false;

		if (IsOnlineServer)
		    return 0;

		gOffsets.GetOffsets();

		VMTBaseManager* clientHook = new VMTBaseManager();
		VMTBaseManager* clientModeHook = new VMTBaseManager();
		VMTBaseManager* panelHook = new VMTBaseManager();
		VMTBaseManager* defRenderHook = new VMTBaseManager();

		ClientFactory = ( CreateInterfaceFn ) GetProcAddress( gSignatures.GetModuleHandleSafe( "client.dll" ), "CreateInterface" );
		EngineFactory = (CreateInterfaceFn)GetProcAddress(gSignatures.GetModuleHandleSafe("engine.dll"), "CreateInterface");
		VGUIFactory = (CreateInterfaceFn)GetProcAddress(gSignatures.GetModuleHandleSafe("vguimatsurface.dll"), "CreateInterface");
		CvarFactory = (CreateInterfaceFn)GetProcAddress(gSignatures.GetModuleHandleSafe("vstdlib.dll"), "CreateInterface");
		SteamFactory = (CreateInterfaceFn)GetProcAddress(GetModuleHandleA("SteamClient.dll"), "CreateInterface");
		MaterialSystemFactory = (CreateInterfaceFn)GetProcAddress(GetModuleHandleA("MaterialSystem.dll"), "CreateInterface");

		gInts.Client = ( CHLClient* )ClientFactory( "VClient017", NULL);
		gInts.EntList = (CEntList*)ClientFactory("VClientEntityList003", NULL );
		gInts.EntList2 = (CEntList2*)ClientFactory("VClientEntityList003", NULL);
		gInts.Engine = ( EngineClient* ) EngineFactory( "VEngineClient013", NULL );
		gInts.Surface = ( ISurface* ) VGUIFactory( "VGUI_Surface030", NULL );
		gInts.RenderView = (CRenderView*)EngineFactory("VEngineRenderView014", NULL);
		gInts.MatSystem = (CMaterialSystem*)MaterialSystemFactory("VMaterialSystem081", NULL);
		gInts.EngineTrace = ( IEngineTrace* ) EngineFactory( "EngineTraceClient003", NULL );
		gInts.ModelInfo = ( IVModelInfo* ) EngineFactory( "VModelInfoClient006", NULL );
		gInts.cvar = (ICvar*)CvarFactory("VEngineCvar004", NULL);
		gInts.ModelRender = (CModelRender*)EngineFactory("VEngineModel016", NULL);
		gInts.EventManager = (IGameEventManager2*)EngineFactory("GAMEEVENTSMANAGER002", NULL);
		gInts.Engine->ClientCmd_Unrestricted("toggleconsole");
		gInts.cvar->ConsoleColorPrintf(Color(200, 200, 32, 255), "CHEAT NACTEN\n");

		if( !gInts.Panels )
		{
			VGUI2Factory = (CreateInterfaceFn)GetProcAddress(gSignatures.GetModuleHandleSafe("vgui2.dll"), "CreateInterface");
			gInts.Panels = ( IPanel* ) VGUI2Factory( "VGUI_Panel009", NULL );

			if( gInts.Panels )
			{
				panelHook->Init(gInts.Panels);
				panelHook->HookMethod(&Hooked_PaintTraverse, gOffsets.iPaintTraverseOffset);
				panelHook->Rehook();
			}
		}

		for (int i = 0; i < 12; i++) 
		{
			ITFMatchGroupDescription* desc = GetMatchGroupDescription(i);

			if (!desc || desc->m_iID > 9) 
				continue;

			if (desc->m_bForceCompetitiveSettings)
			{
				desc->m_bForceCompetitiveSettings = false;
			}
		}

		gInts.globals = *reinterpret_cast<CGlobals **>(gSignatures.GetEngineSignature("A1 ? ? ? ? 8B 11 68") + 8);
		DWORD dwClientModeAddress = gSignatures.GetClientSignature("8B 0D ? ? ? ? 8B 02 D9 05");
		gInts.ClientMode = **(ClientModeShared***)(dwClientModeAddress + 2);
		clientHook->Init(gInts.Client);
		clientHook->HookMethod(&Hooked_KeyEvent, gOffsets.iKeyEventOffset);
		clientHook->Rehook();
		clientModeHook->Init(gInts.ClientMode);
		clientModeHook->HookMethod(&Hooked_CreateMove, gOffsets.iCreateMoveOffset);           
		clientModeHook->Rehook();
		clientHook->HookMethod(&FrameStageNotifyThink, 35);
		clientHook->Rehook();
		defRenderHook->Init(gInts.ModelRender);
		defRenderHook->HookMethod(&Hooked_DrawModelExecute, 19);
		defRenderHook->Rehook();

		HWND thisWindow;
		while (!(thisWindow = FindWindow("Valve001", NULL)))
			Sleep(500);
		eMenu.windowProc = (WNDPROC)SetWindowLongPtr(thisWindow, GWLP_WNDPROC, (LONG_PTR)&Hooked_WndProc);
	}
	return 0;    
}


BOOL APIENTRY DllMain(HMODULE hInstance, DWORD dwReason, LPVOID lpReserved)
{
	if(dwReason == DLL_PROCESS_ATTACH)
	{

		CreateThread( NULL, 0, (LPTHREAD_START_ROUTINE)dwMainThread, NULL, 0, NULL ); 
	}
	return true;
}
