#pragma once
#include "SDK.h"

class IBaseFileSystem;
class KeyValues
{
public:
	static KeyValues* Initialize(KeyValues* kv, char* name);
	static bool LoadFromBuffer(KeyValues* kv, char const *resourceName, const char *pBuffer, IBaseFileSystem* pFileSystem = NULL, const char *pPathID = NULL);

	int m_iKeyName;	       

	char *m_sValue;
	wchar_t *m_wsValue;

	union
	{
		int m_iValue;
		float m_flValue;
		void *m_pValue;
		unsigned char m_Color[4];
	};

	char	m_iDataType;
	char	m_bHasEscapeSequences;	            
	char	m_bEvaluateConditionals;             
	char	unused[1];

	KeyValues *m_pPeer;	      
	KeyValues *m_pSub;	         
	KeyValues *m_pChain;        
};