#pragma once

enum class e_mb
{
	null,
	lclick,
	rclick,
	ldown,
	rdown
};

enum class e_mw
{
	null,
	up,
	down
};

enum class e_focus
{
	null,
	dialog
};

#include "Controls.h"
#include "Styles.h"
class Menu
{
public:
	bool enabled = false;

	bool mouseOver(int x, int y, int w, int h);
	POINT mouse{ 0, 0 }, pmouse{ 0, 0 };

	e_mb mb = e_mb::null;
	e_mw mw = e_mw::null;
	inline int GetFocus() { return focus; }

	void Draw();
	void CreateGUI();

	void OpenDialog(Dialog& dlg);
	void CloseDialog(size_t Index);
	inline bool IsDialogOpen() { return dialogs.size(); }

	void GetInput();
	void EndInput();

	WindowStyle* style = new DefaultStyle();

	WNDPROC windowProc;

	byte keys[256];

	byte last_key = NULL;

	byte key = NULL;

	inline const TabGroup* GetTabs()
	{
		return &Tabs;
	}
private:
	int focus = 0;
	vector<Dialog*> dialogs;

	TabGroup Tabs;
};
extern Menu eMenu;

LRESULT __stdcall Hooked_WndProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam);