#include "Styles.h"
#include "CDraw.h"
#include "CDrawManager.h"

int DefaultStyle::ControlPanel(int x, int y, int w, int h, const char* name)
{
	eDraw.OutlineRect(x, y, w, h, SColor(50, 50, 55));

	int txtMargin = 0;

	int textW = 0, textH = 15;
	if (name)
		gInts.Surface->GetTextSize(gFonts.calibri_light_small, ToWchar(name).c_str(), textW, textH);
	eDraw.DrawRect(x + 1, y + 1, w - 2, textH + txtMargin, SColor(25));
	if (name)
		eDraw.DrawString(x + ((w / 2) - (textW / 2)), y, SColor(150), name, gFonts.calibri_light_small);

	eDraw.DrawLine(x, y + textH + txtMargin, x + w, y + textH + txtMargin, SColor(50, 50, 55));
	x += 1, y += textH + txtMargin + 1, w -= 2, h -= textH + txtMargin + 2;

	eDraw.DrawRect(x, y, w, h, SColor(30, 30, 33));

	return textH + txtMargin + 1;
}

int DefaultStyle::DialogButton(int x, int y, int w, const char* text, bool mouseOver)
{
	eDraw.DrawRect(x, y, w, 15, SColor(42, 42, 48));
	eDraw.OutlineRect(x, y, w, 15, SColor(60));

	eDraw.DrawString(x + 3, y, mouseOver ? SColor(90, 150, 225) : SColor(125, 125, 130), text, gFonts.verdana_bold);

	return 15;
}

void DefaultStyle::Dialog(int x, int y, int w, int h)
{
	eDraw.OutlineRect(x, y, w, h, SColor(58, 58, 70));
	eDraw.DrawRect(x + 1, y + 1, w - 2, h - 2, SColor(36, 36, 40));
}

#define TOPBAR 15
int DefaultStyle::TopBar(int x, int y, int w, const char* title)
{
	eDraw.DrawRect(x, y, w, TOPBAR, SColor(32, 34, 37));

	if (title)
		eDraw.DrawString(x + 10, y, SColor(120), "", gFonts.segoe);

	return TOPBAR;
}